/////////////////////////////////生词本/////////////////////////////////////////////////////////////////////
var scbObjs = [], scbFrom = "";
/* 添加生词本
 * 参数格式json:
 * jsonData = {
 *     "wid":"",                                 //wid
 *     "successCallback":"onScbSuccess",         //成功回调函数
 *     "failedCallback":"onScbFailed"            //失败回调函数
 * }
 */
function addScb(jsonData, obj, from){
    jsonData = parseJson(jsonData);
    scbObjs[jsonData.uwid] = obj;
    if(typeof(from)!="undefined") scbFrom = from;
    try{ dictcn.addScb(JSON.stringify({'uwid':jsonData.uwid,'successCallback':'onScbSuccess','failedCallback':'onScbFailed'})); }catch(e){}
}
/* 生词本添加成功
 * 参数格式json:
 * jsonData = {
 *     "wid":"",                                 //wid
 * }
 */
function onScbSuccess(jsonData){
    jsonData = parseJson(jsonData);
    try{
        var $wordhead = $('.wordhead');
        if(scbFrom=="phrase"){
            scbObjs[jsonData.uwid].src = _resource_+'/images/btn-added.png';
        } else if($wordhead.length>1){
            $wordhead.children('.scbadd').children('img').attr('src',_resource_+'/images/btn-added.png');
        } else {
            scbObjs[jsonData.uwid].src = _resource_+'/images/btn-added.png';
        }
    }catch(e){}
}
///////////////////////////播放声音/////////////////////////////////////////////////////////////////////
var globAnima = null, globCurObj = null,defSoundSrc = '';
/* 本地播放声音
 * 参数格式json:
 * jsonData = {
 *     "lang":"b",                                 //语种
 *     "key":"tuaminoheptane",                    //word
 *     "scode":"QG",                              //scode
 *     "url":"url"                                //mp3地址，支持url发音
 *     "startCallback":"onStartPlaySound",         //开始播放动画js回调
 *     "endCallback":"onEndPlaySound"              //停止播放动画js回调
 * }
 */
function playSound(jsonData,obj){
    jsonData = parseJson(jsonData);
    onEndPlaySound();
    globCurObj = $(obj);
    defSoundSrc = $(obj).attr('src');
    var symbol = jsonData.symbol ? jsonData.symbol : "";
    var pinyin = jsonData.pinyin ? jsonData.pinyin : "";
    var v = jsonData.v ? jsonData.v : "";
    var uwid = jsonData.uwid ? jsonData.uwid : "";
    var aw = jsonData.uwid ? jsonData.aw : "";
    try{ dictcn.playSound(JSON.stringify({'uwid':jsonData.uwid,'lang':jsonData.lang,'key':jsonData.key,'scode':jsonData.scode,'symbol':symbol,'pinyin':pinyin,'v':v,'aw':aw,'startCallback':'onStartPlaySound','endCallback':'onEndPlaySound'})); }catch(e){}
}
         
/* 开始播放动画
 * 参数格式json:
 * jsonData = {
 *     "key":"soundKey"                           
 * }
 */
function onStartPlaySound(jsonData){
    jsonData = parseJson(jsonData);
    try{
        var i = 1;
        globAnima = setInterval(function(){
            if(i>3) i=1;
            globCurObj.attr('src',_resource_+'/images/btn-voice-'+i+'.png');
            i++;
        },200);
    }catch(e){}
}

/* 停止播放动画
 * 参数格式json:
 * jsonData = {
 *     "key":"soundKey"                            //发音单词
 * }
 */
function onEndPlaySound(jsonData){
    jsonData = parseJson(jsonData);
    try{
        clearInterval(globAnima);
        globCurObj.attr('src', defSoundSrc);
    }catch(e){}
}
////////////////////////////查字或词组////////////////////////////////////////////////////////////////////////////
/* 查字
 * 参数格式json:
 * jsonData = {
 *     text:"",                                 //要查询的字
 * }
 */
function searchText(jsonData){
    jsonData = parseJson(jsonData);
    try{ dictcn.searchText(JSON.stringify({'text':jsonData.text})); }catch(e){}
}

/* 查词组
 * 参数格式json:
 * jsonData = {
 *     text:"",                                 //要查询的词组
 *     successCallback:"onPhraseSuccess",
 *     failedCallback:"onPhraseFailed"
 * }
 */
var globPhraseObj = null;
function ajaxSearch(jsonData,obj,display){
    jsonData = parseJson(jsonData);
    if(typeof(display)=="undefined") display = "none";
    if($(obj).next()[0].style.display==display){
        $(obj).children('.arrowbtn').children('img').attr('src',_resource_+'/images/arrow-up.png');
        if($(obj).next().children('.ajax-search').length){ $(obj).next().show();}
        else{
	        try{
	            $(obj).next().html('<div class="phrase-loadding">Loading...</div>');
	            //if(globPhraseObj && globPhraseObj!=obj) $(globPhraseObj).next().html('<div class="phrase-loadding">Failed to load. Please try again later!</div>');
	            $(obj).next().show();
	            globPhraseObj = obj;
	            dictcn.ajaxSearch(JSON.stringify({'text':jsonData.text,'tplName':jsonData.tplName,'from':jsonData.from,'successCallback':'onAjaxSuccess','failedCallback':'onAjaxFailed'}));
	        }catch(e){}
	    }
    } else {
        $(obj).next().hide();
        $(obj).children('.arrowbtn').children('img').attr('src',_resource_+'/images/arrow-down.png');
    }
    if(typeof swiperScroll != 'undefined' && swiperScroll){
    	swiperScroll.resizeFix(true);
    }else if(typeof swiperMain != 'undefined' && swiperMain) {
    	swiperMain.resizeFix(true);
    }
}
/* 生词本添加成功
 * 参数格式json:
 * jsonData = {
 *     wid:"",                                 //wid
 *     html:""                                 //返回的html片段
 * }
 */
function onAjaxSuccess(jsonData){
    jsonData = parseJson(jsonData);
    try{
        var $uwidEle = $('#uwid'+jsonData.uwid);
        $uwidEle.next().html(jsonData.html);
        
        if(typeof onAjaxResize != 'undefined'){
        	onAjaxResize(jsonData.uwid);
        }
        globPhraseObj = null;
        if(auto_uwid) {
            if(parseInt(auto_uwid)!=0){
            	swipeToView($uwidEle[0]);
            }
            
            auto_uwid='';
            if($uwidEle.next()[0].style.display=="none") $uwidEle.next().show();
         }
    }catch(e){}
    if(typeof swiperScroll != 'undefined' && swiperScroll){
    	swiperScroll.resizeFix(true);
        dictcn.nativeLog('update ajax size');
    }else if(typeof swiperMain != 'undefined' && swiperMain) {
    	swiperMain.resizeFix(true);
    }
}

function swipeToView(obj){
	if(typeof swiperMain != 'undefined' && swiperMain) {
		var swipe = swiperMain;
		var pos = -swipe.h.getOffset(obj).top + 5;
		if(typeof swiperScroll != 'undefined' && swiperScroll){
	    	swipe = swiperScroll;
	    	pos += swipe.h.getOffset(swipe.container).top;
	    	swiperMain.setWrapperTransDelay(0);
	    	swiperMain.setWrapperTransition(0);
	    	swiperMain.setWrapperTranslate(-swipe.getHeaderHeight());
	    }
    	swipe.setWrapperTransDelay(0);
	    swipe.setWrapperTransition(0);
		swipe.setWrapperTranslate(pos);
    }
    
}
/* 生词本添加成功
 * 参数格式json:
 * jsonData = {
 *     wid:"",                                 //wid
 *     tip:""                                  //提示信息
 * }
 */
function onAjaxFailed(jsonData){
    jsonData = parseJson(jsonData);
    try{
        document.getElementById('uwid'+jsonData.uwid).innerHTML = jsonData.tip ? jsonData.tip : 'Failed to load the data!';
    }catch(e){}
    if(typeof swiperScroll != 'undefined' && swiperScroll){
    	swiperScroll.resizeFix(true);
    }else if(typeof swiperMain != 'undefined' && swiperMain) {
    	swiperMain.resizeFix(true);
    }
}

///////////////////播放笔顺动画///////////////////////////////////////////////////////////////////////////////////////
/* 弹出笔顺动画窗口
 * 参数格式json:
 * jsonData = {
 *     key:"",                                 //要查询的词组
 * }
 */
function popPlayStroke(jsonData){
     jsonData = parseJson(jsonData);
     var tplname = "stroke.chtml";
     if(typeof(jsonData.tplName)!="undefined") tplname = jsonData.tplName;
     try{ dictcn.popPlayStroke(JSON.stringify({'key':jsonData.text,'tplName':tplname})); }catch(e){}
}
/* 播放笔顺动画
 * 参数格式json:
 * jsonData = {
 *     key:"",                                 //要查询的词组
 *     startCallback:"onStartPlayStroke",
 *     endCallback:""
 * }
 */
var globStrokeObj = null;
function playStroke(jsonData,obj){
    jsonData = parseJson(jsonData);
    globStrokeObj = obj;
    try{ dictcn.playStroke(JSON.stringify({'key':jsonData.text,'startCallback':'onStartPlayStroke','endCallback':''})); }catch(e){}
}
/* 开始播放笔顺动画
 * 参数格式json:
 * jsonData = {
 *     sorder:"",                                 //
 *     cvec:""，                                                                    //
 *     pinyins:""                                //
 * }
 */
function onStartPlayStroke(jsonData){
    jsonData = parseJson(jsonData);
    try{show_stroke_order(jsonData, globStrokeObj);}catch(e){}
    globStrokeObj=null;
}


function nativeLoadImage(jsonData, obj){
    obj.onload = null;
    jsonData = parseJson(jsonData);
    var img_id = "image_id_"+new Date().getTime()+""+Math.floor(Math.random()*10000);
    $(obj).attr("id", img_id);
    try{ dictcn.nativeLoadImage(JSON.stringify({'url':jsonData.url,'image_id':img_id})); }catch(e){}
}

function onImageLoadSuccess(jsonData){
    jsonData = parseJson(jsonData);
    try{ $("#"+jsonData.image_id).attr("src", jsonData.path); }catch(e){}
      
}
function onImageLoadFailed(jsonData){
    jsonData = parseJson(jsonData);
    try{ $("#"+jsonData.image_id).attr("src", _resource_+'/images/default.png'); }catch(e){}
}


//////////////////////////// usefull functions //////////////////////////////////
// 解析json
function parseJson(jsonData){
    try{if(jsonData && !isJson(jsonData)) jsonData = JSON.parse(jsonData);}catch(e){}
    return jsonData;
}
//判断是否json对象
function isJson(obj){
    var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
    return isjson;
}

/* 屏幕取词
 * 参数格式json:
 * jsonData = {
 *     "prevText":"",                                //text before offset
 *     "nextText":"",                                //text after offset
 *     "clientX":"",                                 //current position X
 *     "clientY":"",                                 //current position Y
 *     "query":"",                                   //query key in query action
 *     "action":"highLight|query|close",             //actions
 * }
 * result: popupDictCallback(jsonData) the same format with modified prevText and nextText
 */
function popupDict(jsonData){
	var jsonStr = JSON.stringify(jsonData);
	//document.title = jsonStr;
	try{
		dictcn.popupDict(jsonStr);
	}catch(e){
		
	    /*  callback result for testing
	    	remove the next line in production
	    */
		popupDictCallback(jsonStr);		
	}
}


/* 屏幕取词回调函数
 * 参数格式json:
 * jsonData = {
 *     "prevText":"",                                 //text after split
 *     "nextText":"",                                 //text after split
 *     "action":"highLight|close",                    //return action
 * }
 */
function popupDictCallback(jsonData){
	var jsonObj = parseJson(jsonData);
	if(typeof setHighLight == 'function' && jsonObj.action == 'highLight') setHighLight(jsonObj);
	if(typeof clearPopupDict == 'function' && jsonObj.action == 'close') clearPopupDict(false);
}
