/////////////////////////////////生词本/////////////////////////////////////////////////////////////////////
/* 生词本模块：
*   定义 添加生词本方法 addScb , 成功添加回调方法 onScbSuccess
*/
/////////////////////////////////生词本/////////////////////////////////////////////////////////////////////

/* 添加生词本
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "successCallback":"onScbSuccess",         //成功回调函数
 * }
 */
function addScb(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    try{ dictcn.addScb(JSON.stringify({'uwid':uwid,'successCallback':'onScbSuccess'})); }catch(e){}
}
/* 生词本添加成功
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "in_scb": "1/0"
 * }
 */
function onScbSuccess(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var in_scb = jsonData.in_scb || 0;
    refreshStarIconStatus(uwid,in_scb);
}
//更新按钮样式
function refreshStarIconStatus(uwid,in_scb){
    var star = $('#'+uwid).parent().find('.addStar');
    if(in_scb == '1'){
        $(star).addClass('inscb');
    }
    else if(in_scb == '0') {
        $(star).removeClass('inscb');
    }
}

//////////////////////////// usefull functions //////////////////////////////////////////////
// 解析json
function parseJson(jsonData){
    try{if(jsonData && !isJson(jsonData)) jsonData = JSON.parse(jsonData);}catch(e){}
    return jsonData;
}
//判断是否json对象
function isJson(obj){
    var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
    return isjson;
}
////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////// 学习类应用新增方法 //////////////////////////////////////////////
/* 学习类应用新增方法 模块：
*   定义
*/
//////////////////////////// 学习类应用新增方法 //////////////////////////////////////////////


/* 用户设置保存函数
 * 参数格式json:
 * jsonData = {
 *     "":"",                                 //
 * }
 */
//写入和读取 页面缓存
function setStorage(jsonData) {
    jsonData = parseJson(jsonData);
    var key = jsonData.key || "";
    var value = JSON.stringify(jsonData.value) || "";
    try{ dictcn.setItem(JSON.stringify({'key':key, 'value':value})); }catch(e){}
}
function getStorage(jsonData) {
    jsonData = parseJson(jsonData);
    var key = jsonData.key || "";
    var successCallback = jsonData.successCallback || "";
    try{ dictcn.getItem(JSON.stringify({'key':key, 'successCallback':successCallback})); }catch(e){}
}
// 读取今日权限数据 playTimes
function onPlayTimes(jsonData){
    jsonData = parseJson(jsonData);
    var mydate = new Date();
    curDate = mydate.toLocaleDateString();
    if(jsonData.value){
        jsonData = parseJson(jsonData.value);
    }
    if(curDate == jsonData.date){
        playTimes = jsonData.count;
    }
    else {
        setStorage({"key": "audioPlayTime", "value": {"date": curDate, "count": playTimes}});
    }
}
// getStorage 函数回调函数1
function onLessonFilter(jsonObj){
    jsonObj = parseJson(jsonObj);
    if(!jsonObj.value){
        setStorage({"key":lessonFilter, "value":lesson_filter});
    }
    else {
        lesson_filter = parseJson(jsonObj.value);
    }
    senTitleWordInit(); //中、日显示初始化
}
// getStorage 函数回调函数2
function onPageID(json){
    json = parseJson(json);
    if(!json.value){
        for(var i = 0; i < senlen; i++){
            learnEnd[i] = 0;
        }
        pageObj.learnEnd = learnEnd;
        pageObj.init_Index = init_Index;
        setStorage({"key":pageID, "value":pageObj});
    }
    else {
        var pageSet = parseJson(json.value);
        init_Index = pageSet.init_Index;
        learnEnd = pageSet.learnEnd;
    }
    for(var j in learnEnd){
        if(learnEnd[j] == 1){
            $($('.sentence')[j]).find('.senTitle').addClass('redcolor');
            learnNum++;
        }
    }
    $('#progress').css({'-webkit-transform': 'scaleX('+learnNum/senlen+')'});
    if(learnNum == senlen){
        $('#progress').addClass('full');
    }
    //根据auto_uwid跳转
    if(auto_uwid && (auto_uwid != "0")) {
        showSentence($('#'+auto_uwid).parent().parent().parent(), 1);
        swipeToCur();
    }
    //根据用户上次打开的句子跳转
    else if (init_Index >= 0) {
        showSentence($('.sentence')[init_Index], 1);
        swipeToCur();
    }
}
// getStorage 函数回调函数3
function onAudioSpeed(jsonData){
    jsonData = parseJson(jsonData);
    if(jsonData.value){
        audioSpeed = jsonData.value;
    }
    else {
        setStorage({"key":"audioSpeed", "value":audioSpeed});
    }
    audioSpeedSettingInit(); //音频播放速度设置初始化
}


/** 录音功能模块
*   方法：
*       startRecord  （开始录音方法）
*       onStartRecord  （开始录音后的回调方法）
*       stopRecord  （停止录音方法）
*       onStopRecord  （停止录音后的回调方法）
*/
//录音功能
function startRecord(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    try{ dictcn.startRecord(JSON.stringify({'uwid':uwid,'successCallback':'onStartRecord'})); }catch(e){}
}
function onStartRecord(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || 0;
    //TODO
    if(uwid){
        isRecord = 1;
        recordAudioAnimate(uwid);
                if(!delaytime) {
                    delaytime = 6000;
                }
        //两倍播放时间后自动停止录音
        autoStopRecord = setTimeout(function(){
            var uwid = $('.sentence.active').attr('name');
            var json = {'uwid': uwid};
            json.invaild = 1;
            stopRecord(json);
        }, delaytime);
    }
}
//停止录音
function stopRecord(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var invaild = jsonData.invaild || "";
    try{ dictcn.stopRecord(JSON.stringify({'uwid':uwid, "invaild":invaild,'successCallback':'onStopRecord'})); }catch(e){}
}
function onStopRecord(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || 0;
    var filePath = jsonData.filePath || 0;
    //TODO
    if(uwid){
        isRecord = 0;
        stopRecordEvent(uwid,filePath);
    }    
}

/** 更新录音播放按钮状态模块
*   参数：
*       
*   方法：
*       refreshRecordPath （更新录音播放按钮状态）
*       onRefreshRecordPath （更新录音播放按钮状态 回调函数）
*/
//更新录音播放按钮状态
function refreshRecordPath(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    try{ dictcn.refreshRecordPath(JSON.stringify({'uwid':uwid,'successCallback':'onRefreshRecordPath'})); }catch(e){}
}
function onRefreshRecordPath(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var filePath = jsonData.filePath || "";
    //TODO
    refreshListenSoundBtn(uwid, filePath);
}

//更新添加到生词本按钮状态
function refreshFavorite(jsonData){
    jsonData = parseJson(jsonData);
     var uwid = jsonData.uwid || "";
     try{ dictcn.refreshFavorite(JSON.stringify({'uwid':uwid,'successCallback':'onRefreshFavorite'})); }catch(e){}
}
function onRefreshFavorite(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var isFavorite = jsonData.isFavorite || 0;//1|0
    //TODO
    refreshStarIconStatus(uwid,isFavorite);
}

/** 跳转到发音页面
*   参数：
*       
*   方法：
*       jumpTrain （更新录音播放按钮状态）
*/
//更新录音播放按钮状态
function jumpTrain(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    try{ dictcn.jumpTrain(JSON.stringify({'uwid':uwid})); }catch(e){}
}

/** 调用激活面板
*   参数：
*       
*   方法：
*       noticeToActivate （更新录音播放按钮状态）
*/
function noticeToActivate(){
    try{ dictcn.noticeToActivate(); }catch(e){}
}

/** js开给native接口：更新权限参数isActivate
*   参数：
*       status //标记状态的数值
*   方法：
*       refreshActivate （更新录音播放按钮状态）
*/
function refreshActivate(jsonData){
    jsonData = parseJson(jsonData);
    var status = jsonData.status;
    if(status >= 0){
    	isActivate = status;
    }
}

/**反馈当前打开词条信息给客户端
*   参数：
*       id  //pageID
*       uwid  //当前词条uwid
*       state： “1/0”  //是否已学习
*/
function refreshStudyStatus(jsonData){
    jsonData = parseJson(jsonData);
     var id = jsonData.id || "";
     var uwid = jsonData.uwid || "";
     var state = "1";
     try{ dictcn.refreshStudyStatus(JSON.stringify({'id':id, 'uwid':uwid, 'state':state})); }catch(e){}
}

//屏幕重新唤醒时 native 调用音频 reload方法
function audioReLoad(){
    if(isPlayingAll){
        if(listenVoice.currentTime == 0){
            isPlayingAllTest();
            listenVoice.load();
        }
    }
}