var lesson_filter = {"lesson_filter":3}; // 中、日标题显示设置参数【全局】
var init_Index = 0; // 上次使用最后打开的句子【当前页】
var learnEnd = {}; //已学句子标红设置【当前页】
var pageObj = {}; //记录pageID项目下设置的对象
var learnNum = 0; //已经学习的句子数目
var senlen = $('.sentence').length; //总句子数目
var maxIndex = senlen-1; //句子index的最大值
var lastIndex = -1, curIndex = -1; //记录上次打开和当前打开的句子
var isChangeCurSen = 0; //标记是否在当前句子中切换了声音链接(0为课程声，1为录音声，2为对话声)
var islisDialoSound = 0, curDialoBtn; //是否正在听对话发音 || 当前点击的发音对话按钮
var loaded = 0; //标记声音是否载入成功
var isRecord = 0, isListening = 0; //正在录音/正在听录音
var isPlayingAll = 0; //是否正在播放全部例句声音
var delaytime; //两倍时间自动停止录音的延时标记
var swiperMain,scrollContainer = []; //swiper对象
var audioSpeed = 1; //音频播放速度设置
var keepPlay = 0;
var isSwipering;

$(function(){
	//页面设置初始化
	function settingInit(){
		getStorage({"key":"audioSpeed", "successCallback":"onAudioSpeed"});
		getStorage({"key":lessonFilter, "successCallback":"onLessonFilter"});
		getStorage({"key":pageID, "successCallback":"onPageID"});

		//判断录音数据是否已存在、生词本是否已添加
		$('.sentence').each(function(){
			var uwid = $(this).attr('name');
			var json = {"uwid": uwid};
			refreshRecordPath(json);
			refreshFavorite(json);
		});
	}
	//框架尺寸调整方法
	function fixPageHeight(){
		var height = $(window).height() - $('#nav').height();
		$(".swiper-main").css('height', height);
		$(".scroll-container").css('height', height);
		var newHeight = height - $('#footer').height();
		$("#commSen").css('height', newHeight);
		$("#footer").css('width', $(window).width());
		var width = $('td').width();
		$('td').css('height', width);
	}

	init(); //调用全局初始化函数
	function init(){
		FastClick.attach(document.body);

		//定义框架尺寸
		$(window).on('resize',fixPageHeight);
		fixPageHeight();

		//初始化滑动组件
		swiperMain = new Swiper('.swiper-main',{
			mousewheelControl : true,
			onSlideChangeStart: function(swiper){
				$('#nav span').removeClass('active');
				$('#navbtn'+swiper.activeIndex).addClass('active');
				isSwipering = 1;
				setTimeout(function(){isSwipering = 0;},50);
				clickConflictTest();
			}
		});

		$('.scroll-container').each(function(){
			var sc = $(this).swiper({
				scrollContainer: true,
				mousewheelControl : true,
			    mode:'vertical'
			});
			scrollContainer.push(sc);
		});
		
		settingInit(); // 页面设置初始化

		showSenInit(); //句子弹开初始化

		//绑定nav点击事件
		$('#nav span').on('click',function(){
			swiperMain.swipeTo($(this).attr('index'));
		});

		//绑定设置图标点击事件
		$('#optionBtn').on('click',function(){
			if($('#optionPanel').hasClass('show')){
				$('#optionPanel').removeClass('show');
			}
			else {
				$('#optionPanel').addClass('show');
			}
		});

		//绑定 lisDialoSound 按钮 听对话点击事件
		$('.lisDialoSound').on('click',lisDialoSoundClick);

		audioPlayInit(); //音频播放功能初始化

		audioRecordInit(); //录音与播放录音初始化

		addScbInit(); //添加生词本初始化

	}

	
	function showSenInit(){
		//为每条句子绑定click事件
		$('.sentence').on('click',function(){
			if(!isSwipering){
				clickConflictTest();
				showSentence(this);
			}
		});
	}


/** 音频播放处理模块
*	参数：
*		isPlaying  //标记是否正在播放
*		keepPlay  //标记是否需要继续播放下一条
*	方法：
*		playProgress  //音频播放进度方法
*		circleRotate  //圆形进度条转动方法
*		playAllSoundInit  //playAllSound 按钮初始化
*		keepPlaying  //继续播放下一条方法
*		audioPlayInit  //音频播放功能初始化（音频监听器）
*/
	//音频播放进度方法
	function playProgress(adu,nu){
		var perc = adu.currentTime / adu.duration;
		circleRotate(perc,nu);
		if((perc < 1) && (!adu.paused)){
			setTimeout(function(){
				playProgress(adu,nu);
			},100);
		}
	}
	//圆形进度条转动方法
	function circleRotate(perc,nu){
		var angle = 360*perc;
		var innerR = $('.sentence.active').find('.innerRight')[nu];
		var innerL = $('.sentence.active').find('.innerLeft')[nu];
		if(angle<180){
			$(innerR).css({'-webkit-transform': 'rotate('+angle+'deg)'});
		}
		else {
			$(innerR).css({'-webkit-transform': 'rotate(180deg)'});
			$(innerL).css({'-webkit-transform': 'rotate('+(angle-180)+'deg)'});
		}
	}

	//playAllSound 按钮初始化
	function playAllSoundInit(){
		var This = $('#playAllSound');
		if(!isPlayingAll) {
			clickConflictTest();
			$(This).addClass('playing');
			isPlayingAll = 1;
			//未打开任何句子，跳转到第一条
			if((curIndex < 0) || (curIndex == maxIndex)){
				showSentence($('.sentence')[0]);
			}
			swipeToCur();
			var sen = $('.sentence')[curIndex];
			//判断是否需要替换链接
			if(isChangeCurSen) {
				playOrPauseAudio($(sen).find('.btnGroup')[0],1);
				isChangeCurSen = 0;
			}
			//判断当前打开句子是否在播放
			else if(listenVoice.paused){
				playOrPauseAudio($(sen).find('.btnGroup')[0]);
			}
			//判断是否需要跳过当前句子
			if($(sen).find('.btnGroup').attr('skipPlay')){
				keepPlaying();
			}
			keepPlay = 1;
		}
		else {
			$(This).removeClass('playing');
			isPlayingAll = 0;
			keepPlay = 0;
			listenVoice.pause();
	        isPlaySound = 0;
	        var icon = $(".sentence.active").find('.playSound')[0];
	        $(icon).removeClass('stopSound');
		}
	}
	
	//继续播放下一条方法
	function keepPlaying(){
		if(curIndex < maxIndex){
			var id = curIndex+1;
			var sen = $('.sentence')[id];
			showSentence(sen);
			swipeToCur();
			
			if($('.sentence.active').find('.btnGroup').attr('skipPlay')){
				keepPlaying();
			}
		}
		else if(curIndex == maxIndex) {
			loaded = 0;
			listenVoice.load();
			playAllSoundInit();
		}
	}

	//音频播放功能初始化
	function audioPlayInit(){
		//为播放按钮增加侦听器事件
		$('.playSound').on('click',function(e){
			e.stopPropagation();
			var skipPause = 0;
			if (!isPlaySound) {
				clickConflictTest();
			}
			else {
				if(isPlayingAll){
					isPlayingAllTest();
					skipPause = 1;
				}
			}
			if(isChangeCurSen) {
				playOrPauseAudio($(this).parent(),1);
				isChangeCurSen = 0;
			}
			else {
				if(!skipPause){
					playOrPauseAudio($(this).parent());
				}
			}
		});
		$('#listenVoice').on('canplay',function(){
			loaded = 1;
			if(this.autoplay){
				this.autoplay = 0;
				if(isChangeCurSen == 1){
					isListening = 1;
					islisDialoSound = 0;
					isPlaySound = 0;
		            this.play();
				}
				else if(isChangeCurSen == 2){
					islisDialoSound = 1;
					isListening = 0;
					isPlaySound = 0;
		            this.play();
				}
				else {
					var icon = $('.sentence.active').find('.playSound')[0];
		        	$(icon).addClass('stopSound');
		            isPlaySound = 1;
		            isListening = 0;
		            islisDialoSound = 0;
		            this.play();
		            delaytime = listenVoice.duration * 2000;
		            if(delaytime > 100000){
			            setTimeout(function(){
				            delaytime = listenVoice.duration * 2000;
			            },100);
			        }
				}
			}
			else {
				if(!isChangeCurSen){
					delaytime = listenVoice.duration * 2000;
					if(delaytime > 100000){
						listenVoice.currentTime = 0.01;
			            setTimeout(function(){
				            delaytime = listenVoice.duration * 2000;
			            },200);
			        }
			    }
			}
		});
		$('#listenVoice').on('playing',function(){
			if(isListening){
				var btn = $('.sentence.active').find('.listenSound')[0];
				$(btn).addClass('lis');
				preparePlayProgress(1);
				playProgress(this,1);
			}
			else if(islisDialoSound){
				dialoSoundAnimateStart();
			}
			else {
				preparePlayProgress(0);
				playProgress(this,0);
			}
		});
		$('#listenVoice').on('pause',function(){
			if(isListening){
				isListening = 0;
				var btn = $('.sentence.active').find('.listenSound')[0];
	            $(btn).removeClass('lis');
	            endPlayProgress(1);
	        }
	        else if(islisDialoSound){
				dialoSoundAnimateStop();
				islisDialoSound = 0;
			}
	        else {
	        	endPlayProgress(0);
	        }
		});
		$('#listenVoice').on('ended',function(){
			if(isListening){
				var btn = $('.sentence.active').find('.listenSound')[0];
				$(btn).removeClass('lis');
				isListening = 0;
				var cir = $('.sentence.active').find('.circleBorder')[1];
				$(cir).removeClass("show");
			}
			else if(islisDialoSound){
				dialoSoundAnimateStop();
				islisDialoSound = 0;
			}
			else {
				var cir = $('.sentence.active').find('.circleBorder')[0];
				$(cir).removeClass("show");
				var icon = $('.sentence.active').find('.playSound')[0];
				$(icon).removeClass('stopSound');
				if(keepPlay){
					setTimeout(keepPlaying, 500);
				}
				else {
					if(!isIOS){
						loaded = 0;
						this.load();
					}
				}
				isPlaySound = 0;
			}
		});
		$('#listenVoice').on('stalled',function(){
			if(!loaded){
				loaded = 0;
				this.autoplay = 1;
				this.load();
			}
		});
		$('#listenVoice').on('error',function(e){
			if((!isChangeCurSen)&&(this.error.code == 4)&&(this.getAttribute('src'))){
				var btnG = $('.sentence.active').find('.btnGroup')[0];
				$(btnG).addClass('error');
				$(btnG).attr('skipPlay', 1);
			}
		});
		$('#playAllSound').click(playAllSoundInit);
	}

/** 录音与播放录音模块
*	参数：
*		recordPlayAni  //录音动画标记
*	方法：
*		recordPlayAudioAnimate  //录音播放动画方法入口
*		recordPlayAudioIconAnimate  //录音播放动画切换图标方法
*		stoprecordPlayAudioAnimate  //移除录音播放动画
*		audioRecordInit  //录音与播放录音初始化
*/
	
	//录音与播放录音初始化
	function audioRecordInit(){
		$('.recordSound').on('click',function(e){
			e.stopPropagation();
			if(!isRecord){
				clickConflictTest();
			}
			var uwid = $(this).attr('id');
			var json = {'uwid': uwid};
			if(!this.state){
				this.state = 1;
				if(!isRecord){
					startRecord(json);
				}
				else {
					json.invaild = 1;
					stopRecord(json);
					clearTimeout(autoStopRecord);
				}
			}
		});
		//为录音播放按钮添加监听事件
		$('.listenSound').on('click',function(e){
	        e.stopPropagation();
	        if(!isListening){
	        	clickConflictTest();
	        	var index = $(this).parent().attr('index')-1;
	        	isChangeCurSen = 1;
		        listenVoice.src = recordAudioPath[index];
		        loaded = 0;
		        listenVoice.autoplay = 1;
		        listenVoice.load();
	        }
	        else {
	            listenVoice.pause();
	        }
	    });
	}

	// 播放对话按钮点击方法
	function lisDialoSoundClick(e){
		e.stopPropagation();
		if(islisDialoSound && curDialoBtn==this){
			listenVoice.pause();
		}
		else{
			clickConflictTest();
			curDialoBtn = this;
			isChangeCurSen = 2;
			var nu = $(this).parent().index()/2 + 1;
			if(audioSpeed == 1){
	        	listenVoice.src = audioPrefix + audioPath[curIndex][nu];
	        }
	        else if(audioSpeed == 0.5){
	        	listenVoice.src = audioPrefix + slowAudioPath[curIndex][nu];
	        }
	        loaded = 0;
	        listenVoice.autoplay = 1;
	        listenVoice.load();
		}
	}

/** 添加生词本模块
*	方法：
*		addScbInit  //添加生词本按钮初始化
*/
	//添加生词本按钮初始化
	function addScbInit(){
		$('.addStar').on('click',function(e){
			e.stopPropagation();
			clickConflictTest();
			var uwid = $(this).parent().find('.recordSound').attr('id');
			var json = {'uwid': uwid};
			addScb(json);
		});
	}




});



//定义中、日或是中+日
//id值可能是：1（中）、2（日）、3（中+日）
function senTitleWordChange(id) {
    if(id){
        if (id==1) {
            $('.senTitleWord').each(function(){
                $(this).removeClass('only-ri');
                $(this).addClass('only-zhong');
            });
        }
        else if(id==2){
            $('.senTitleWord').each(function(){
                $(this).removeClass('only-zhong');
                $(this).addClass('only-ri');
            });
        }
        else if (id==3) {
            $('.senTitleWord').each(function(){
                $(this).removeClass('only-zhong');
                $(this).removeClass('only-ri');
            });
        }

        $('.sentence.active').find('.senTitleWord').each(function(){
                $(this).removeClass('only-ri only-zhong');
        });
    }
}
//中、日显示初始化
function senTitleWordInit(){
    //根据上次保存设置初始化
    if(lesson_filter) {
        senTitleWordChange(lesson_filter.lesson_filter);
        if(lesson_filter.lesson_filter == 1){
            showControlActive($('#onlyZhong'));
            scrollContainer[0].resizeFix(1);
        }
        else if(lesson_filter.lesson_filter == 2){
            showControlActive($('#onlyRi'));
            scrollContainer[0].resizeFix(1);
            if($('.sentence.active').length){
            	swapHtmlText($('.sentence.active').find('.senTitleWord')[0]);
            }
        }
        else if(lesson_filter.lesson_filter == 3){
            showControlActive($('#zhongri'));
            $('.senNum').addClass('zhongri');
        }
    }
    //绑定三个按钮事件
    $('#onlyZhong').click(function(){
        if(lesson_filter.lesson_filter != 1){
    		senTitleWordChange(1);
    		scrollContainer[0].resizeFix(1);
    		if(lesson_filter.lesson_filter == 2){
    			$('.sentence.active').each(function(){
    				swapHtmlText($(this).find('.senTitleWord'));
    			});
    		}
    		else {
    			swipeToCur();
    			$('.senNum').removeClass('zhongri');
    		}
	        lesson_filter.lesson_filter = 1;
	        setStorage({"key":lessonFilter, "value":lesson_filter});
	        showControlActive(this);
    	}
    });
    $('#onlyRi').click(function(){
        if(lesson_filter.lesson_filter != 2){
	        senTitleWordChange(2);
	        scrollContainer[0].resizeFix(1);
	        $('.sentence.active').each(function(){
				swapHtmlText($(this).find('.senTitleWord'));
			});
			if(lesson_filter.lesson_filter == 3){
				swipeToCur();
				$('.senNum').removeClass('zhongri');
			}
	        lesson_filter.lesson_filter = 2;
	        setStorage({"key":lessonFilter, "value":lesson_filter});
	        showControlActive(this);
	    }
    });
    $('#zhongri').click(function(){
        if(lesson_filter.lesson_filter != 3){
	        senTitleWordChange(3);
	        if(lesson_filter.lesson_filter == 2){
    			$('.sentence.active').each(function(){
    				swapHtmlText($(this).find('.senTitleWord'));
    			});
    		}
    		scrollContainer[0].resizeFix(1);
    		swipeToCur();
    		$('.senNum').addClass('zhongri');
	        lesson_filter.lesson_filter = 3;
	        setStorage({"key":lessonFilter, "value":lesson_filter});
	        showControlActive(this);
	    }
    });
}
//音频播放速度设置初始化
function audioSpeedSettingInit(){
	//根据上次保存设置初始化
	if(audioSpeed == 0.5){
		$('#normalSpeed').removeClass('active');
		$('#slowSpeed').addClass('active');
		if($('.sentence.active').length){
			listenVoice.src = audioPrefix + slowAudioPath[curIndex][0];
			loaded = 0;
			listenVoice.load();
		}
	}
	// 绑定两个设置按钮点击事件
	$('#slowSpeed').click(function(){
		if(audioSpeed == 1){
			$('#normalSpeed').removeClass('active');
			$(this).addClass('active');
			audioSpeed = 0.5;
			setStorage({"key":"audioSpeed", "value":audioSpeed});
			if($('.sentence.active').length){
				if(isPlaySound){
					listenVoice.src = audioPrefix + slowAudioPath[curIndex][0];
				    loaded = 0;
		            listenVoice.load();
				}
				clickConflictTest();
			}
			setTimeout(function(){
				$('#optionPanel').removeClass('show');
			},500);
		}
	});
	$('#normalSpeed').click(function(){
		if(audioSpeed == 0.5){
			$('#slowSpeed').removeClass('active');
			$(this).addClass('active');
			audioSpeed = 1;
			setStorage({"key":"audioSpeed", "value":audioSpeed});
			if($('.sentence.active').length){
				if(isPlaySound){
					listenVoice.src = audioPrefix + audioPath[curIndex][0];
				    loaded = 0;
		            listenVoice.load();
				}
				clickConflictTest();
			}
			setTimeout(function(){
				$('#optionPanel').removeClass('show');
			},500);
		}
	});
}

function showControlActive(This){
    $('#showControl').find('li').each(function(){
        $(this).removeClass('active');
    });
    $(This).addClass('active');
}

//html文本互换
function swapHtmlText(senTW){
	var htmlText = $(senTW).find('.zhong').html();
    $(senTW).find('.zhong').html($(senTW).find('.ri').html());
    $(senTW).find('.ri').html(htmlText);
}

//句子弹开与关闭
function showSentence(sen,first) {
    lastIndex = curIndex;
    curIndex = $(sen).index();
    //判断两次点击是否是同一条句子，分情况处理
    if(curIndex == lastIndex){
        $(sen).removeClass('active');
        stopAudio();
        curIndex = -1;
    }
    else {
        if (lastIndex >= 0) {
            var oldSen = $('.sentence')[lastIndex];
            $(oldSen).removeClass('active');
            stopAudio();
        }
        $(sen).addClass('active');
        if(first){
            $(sen).find('.progressIcon').hide();
            if(audioSpeed == 1){
	        	listenVoice.src = audioPrefix + audioPath[curIndex][0];
	        }
	        else if(audioSpeed == 0.5){
	        	listenVoice.src = audioPrefix + slowAudioPath[curIndex][0];
	        }
		    loaded = 0;
            listenVoice.load();
        }
        else {
            playOrPauseAudio($(sen).find('.btnGroup')[0],1);
        }
    }
    scrollContainer[0].resizeFix(1);
    //处理已学习记录的样式变化
    if(curIndex >= 0 && !(learnEnd[curIndex])){
        $(sen).find('.senTitle').addClass('redcolor');
        learnEnd[curIndex] = 1;
        learnNum++;
        $('#progress').css({'-webkit-transform': 'scaleX('+learnNum/senlen+')'});
        if(learnNum == senlen){
            $('#progress').addClass('full');
        }
    }
    init_Index = curIndex;
    pageObj.init_Index = init_Index;
    pageObj.learnEnd = learnEnd;
    setStorage({"key":pageID, "value":pageObj});

    if(lesson_filter.lesson_filter == 2){
        activeRi(sen,"only-ri");
    }
    else if(lesson_filter.lesson_filter == 1){
    	activeRi(sen,"only-zhong");
    }

    //反馈当前打开词条信息给客户端
    var json = {};
    json.id = pageID;
    json.uwid = $(sen).attr('name');
    refreshStudyStatus(json);
    
}
//处理只显示日文情况下，active变化的问题
function activeRi(sen,className){
    if(curIndex >= 0) {
        var senTW = $(sen).find('.senTitleWord')[0];
        $(senTW).removeClass(className);
        if(className == "only-ri"){
        	swapHtmlText(senTW);
        }
        if(lastIndex >= 0) {
            var oldSen = $('.sentence')[lastIndex];
            var senTW = $(oldSen).find('.senTitleWord')[0];
	        $(senTW).addClass(className);
	        if(className == "only-ri"){
	        	swapHtmlText(senTW);
	        }
        }
    }
    else {
        var senTW = $(sen).find('.senTitleWord')[0];
        $(senTW).addClass(className);
        if(className == "only-ri"){
        	swapHtmlText(senTW);
        }
    }
}

/** 音频播放处理模块
*   参数：
*       isPlaySound (标记音频是否正在播放)
*   方法：
*       playOrPauseAudio（播放或暂停）
*       stopAudio （停止播放）
*/
//播放或暂停音频音频
var isPlaySound = 0; //是否正在播放声音
function playOrPauseAudio(btng,changeSen){
    var icon = $(btng).find('.playSound')[0];
    if(changeSen){
        //加载音频资源
        var index = $(btng).attr('index')-1;
		isChangeCurSen = 0;
        loaded = 0;
        listenVoice.autoplay = 1;
        if(audioSpeed == 1){
        	listenVoice.src = audioPrefix + audioPath[index][0];
        }
        else if(audioSpeed == 0.5){
        	listenVoice.src = audioPrefix + slowAudioPath[index][0];
        }
        listenVoice.load();
    }
    else {
        if (listenVoice.paused) {
            listenVoice.play();
            $(icon).addClass('stopSound');
            isPlaySound = 1;
            return;
        }
        listenVoice.pause();
        isPlaySound = 0;
        $(icon).removeClass('stopSound');
    }
}
function stopAudio(){
    listenVoice.src = "";
    isPlaySound = 0;
}

//跳转到当前打开句子方法
function swipeToCur(){
    var dis = 0;
    for(var i = 0; i < curIndex; i++){
        dis += $($('.sentence')[i]).height();
    }
    scrollContainer[0].setWrapperTranslate(0, -dis,0);
}

/** 录音功能模块
*   参数：
*       recordani  （标记录音动画）
*       recordAudioPath  (记录录音文件路径)
*   方法：
*       recordAudioAnimate  （开始录音后的动画）
*       recordAudioIconAnimate （录音动画循环体）
*       stopRecordEvent  （停止录音后清除动画，调用更新录音文件方法）
*       refreshListenSoundBtn （更新录音文件方法）
*/
var recordAudioPath = {};
var autoStopRecord; //自动两倍延时关闭录音
//录音动画方法
var recordani;
function recordAudioAnimate(uwid){
    var btn = $("#"+uwid)[0];
    btn.state = 0; //标记按钮接收点击事件
    $(btn).addClass('work');
    var curr = 0;
    recordani = setInterval(function(){
        curr = (curr+1) % 5;
        recordAudioIconAnimate(curr,btn);
    }, 200);
}
function recordAudioIconAnimate(curr,icon){
    var last = curr-1;
    if(last<0){
        last = 4;
    }
    $(icon).removeClass('ani'+last);
    if(curr>0){
        $(icon).addClass('ani'+curr);
    }
}
//停止录音方法
function stopRecordEvent(uwid,filePath){
    //清除录音按钮动画
    clearInterval(recordani);
    var btn = $("#"+uwid)[0];
    btn.state = 0; //标记按钮接收点击事件
    $(btn).removeClass('work');
    for(var i=1; i<5; i++){
        $(btn).removeClass('ani'+i);
    }
    if(filePath){
        refreshListenSoundBtn(uwid, filePath);
    }
}
//更新播放录音状态
function refreshListenSoundBtn(uwid, filePath){
    var btn = $("#"+uwid);
    //显示播放录音按钮，并为 recordVoice 声音标签设置声音链接
    var listenBtn = $(btn).parent().find('.listenSound');
    var index = $(btn).parent().attr('index')-1;
    $(listenBtn).removeClass('hide');
    recordAudioPath[index] = filePath;
}

//播放对话按钮动画
function dialoSoundAnimateStart(){
	var btn = $(curDialoBtn)[0];
	btn.state = 0;
	btn.ani = 1;
	dialoSoundAni(btn);
}
function dialoSoundAni(btn){
	$(btn).removeClass('state'+btn.state);
	btn.state = ++btn.state>2 ? 0 : btn.state;
	$(btn).addClass('state'+btn.state);
	setTimeout(function(){
		if(btn.ani){
			dialoSoundAni(btn);
		}
	},300);
}
function dialoSoundAnimateStop(){
	var btn = $(curDialoBtn)[0];
	btn.ani = 0;
	$(btn).removeClass('state1 state2').addClass('state0');
}

//播放进度动画准备
function preparePlayProgress(nu){
	var cir = $('.sentence.active').find('.circleBorder')[nu];
	$(cir).addClass("show");
	var pro = $('.sentence.active').find('.progressIcon')[nu];
	$(pro).show();
	var inL = $('.sentence.active').find('.innerLeft')[nu];
	$(inL).css({'-webkit-transform': 'rotate(0deg)'});
}
//播放进度动画收尾
function endPlayProgress(nu){
	var cir = $('.sentence.active').find('.circleBorder')[nu];
	$(cir).removeClass("show");
	var pro = $('.sentence.active').find('.progressIcon')[nu];
	$(pro).hide();
	var inR = $('.sentence.active').find('.innerRight')[nu];
	var inL = $('.sentence.active').find('.innerLeft')[nu];
	$(inR).css({'-webkit-transform': 'rotate(0deg)'});
	$(inL).css({'-webkit-transform': 'rotate(0deg)'});
}

/** 冲突检测模块
*	方法：
*		clickConflictTest  //点击事件冲突检测方法
*/
//点击事件冲突检测方法
function clickConflictTest(){
	if(isPlaySound){
		listenVoice.pause();
		var icon = $('.sentence.active').find('.playSound')[0];
        $(icon).removeClass('stopSound');
        endPlayProgress(0);
        isPlaySound = 0;
	}
	if(isRecord){
		var uwid = $('.sentence.active').attr('name');
		var json = {'uwid': uwid};
		json.invaild = 0;
		stopRecord(json);
		clearTimeout(autoStopRecord);
		isRecord = 0;
	}
	if(isListening){
		listenVoice.pause();
		var btn = $('.sentence.active').find('.listenSound')[0];
		$(btn).removeClass('lis');
		endPlayProgress(1);
        isListening = 0;
	}
	if(islisDialoSound){
		listenVoice.pause();
		islisDialoSound = 0;
		dialoSoundAnimateStop();		
	}
	isPlayingAllTest();
}
//isPlayingAll冲突检测
function isPlayingAllTest(){
	if(isPlayingAll){
		$('#playAllSound').removeClass('playing');
		isPlayingAll = 0;
		keepPlay = 0;
		listenVoice.pause();
        isPlaySound = 0;
        var icon = $(".sentence.active").find('.playSound')[0];
        $(icon).removeClass('stopSound');
	}
}